function [] = rezultate1(x0, h, func)
    exec('functii/functie.sci');
    exec('functii/derivare.sci')
    exec('functii/alte_functii.sci');

    select func
    case 1 then
        txt = 'x^2';
    case 2 then
        txt = 'radical(x)';
    case 3 then
        txt = 'exp(x)';
    case 4
        txt = 'ln(x)';
    case 5
        txt = 'sin(x)';
    case 6
        txt = 'tg(x)';
    end;			

    /////////////////

    // afisarea valorii exacte a derivatei
    printf('\n\n-----------------------------------------'+ ...
    '---------------------');
    printf('\n\nFunctia: f(x)=%s',txt);
    printf('\nPunctul in care se calculeaza derivata: x0 = %14.12f', x0);
    printf('\nValoarea exacta a derivatei: %14.12f', derivata_exacta(x0,func));

    // derivare cu pas introdus de utilizator
    printf('\n\nCalculul derivatei cu pasul de derivare impus: %f', h);
    printf('\nCentrata (II):   %f \tEroarea absoluta: %e', ...
    centrataII(x0,h,func), abs(centrataII(x0,h,func)- ...
    derivata_exacta(x0,func)));
    printf('\nProgresiva (I):  %f \tEroarea absoluta: %e', ...
    progresivaI(x0,h,func), abs(progresivaI(x0,h,func)- ...
    derivata_exacta(x0,func)));
    printf('\nRegresiva (I):   %f \tEroarea absoluta: %e', ...
    regresivaI(x0,h,func), abs(regresivaI(x0,h,func)- ...
    derivata_exacta(x0,func)));
    printf('\nProgresiva (II): %f \tEroarea absoluta: %e', ...
    progresivaII(x0,h,func), abs(progresivaII(x0,h,func)- ...
    derivata_exacta(x0,func)));
    printf('\nRegresiva (II):  %f \tEroarea absoluta: %e', ...
    regresivaII(x0,h,func), abs(regresivaII(x0,h,func)- ...
    derivata_exacta(x0,func)));

    // derivare cu determinarea pasului optim
    // derivata centrata cu pas optim se calculeaza ca medie aritmetica
    // a celor doua (regresiva cu pas optim si progresiva cu pas optim)
    [dP, ho] = progresiva_optim(x0,h,func);
    [dR] = progresiva_optim(x0,-h,func);
    dC = (dR+dP)/2;
    printf('\n\nCalculul derivatei cu determinarea pasului optim: %e', ho);
    printf('\nCentrata:   %14.12f \tEroarea absoluta: %e', ...
    dC, abs(dC-derivata_exacta(x0,func)));
    printf('\nProgresiva: %14.12f \tEroarea absoluta: %e', ...
    dP, abs(dP-derivata_exacta(x0,func)));
    printf('\nRegresiva:  %14.12f \tEroarea absoluta: %e', ...
    dR, abs(dR-derivata_exacta(x0,func)));
endfunction

function [] = rezultate2()
    exec('functii/derivare.sci');
    exec('functii/alte_functii.sci');

    x0 = %pi/4;
    de_ex = cos(x0);

    k = 0;
    hini = 0.0000001;
    pash = 0.0000001;
    hmax = 0.001;
    minerr2 = 1e+7;
    herrmin2 = hini;
    for h = hini:pash:hmax,
        k = k+1;
        hVect(k) = h;

        de_ord2 = (sin(x0+h) - sin(x0-h)) / (2*h);
        err2Vect(k) = abs(de_ord2 - de_ex);
        if (err2Vect(k)<%eps)
            err2Vect(k) = %eps;
        end;
        if (err2Vect(k)<minerr2) then
            minerr2 = err2Vect(k);
            herrmin2 = h;
        end;

        if (k/500 == int(k/500))
            printf("\n\nDiferente finite centrate de ordinul 2:\n");
            printf("Eroarea: %e\n",err2Vect(k));
            printf("Pasul de derivare: %f\n",h);
        end;
    end;

    // ordinul 2
    printf("\n\nDiferente finite centrate de ordinul 2:\n");
    printf("Eroarea minima: %e\n",minerr2);
    printf("Pasul de derivare: %f\n",herrmin2);

    //xclear();
    xname('Graficul erorii in functie de pasul ...
    de derivare');
    xtitle('Eroarea de derivare pentru ordinul 2','h','err(h)');
    xsetech([0,0,1,1]);
    plot2d('ll',hVect',err2Vect',5);
    xgrid();
    wait2close();

    k=0;
    clear hVect;
    hini = 0.0001;
    pash = 0.0001;
    hmax = 0.1;
    minerr4 = 1e+7;
    herrmin4 = hini;
    for h = hini:pash:hmax,
        k = k+1;
        hVect(k) = h;

        de_ord4 = (sin(x0-2*h) - 8*sin(x0-h) + ...
        8*sin(x0+h) - sin(x0+2*h)) / (12*h);
        err4Vect(k) = abs(de_ord4 - de_ex);
        if (err4Vect(k)<%eps)
            err4Vect(k) = %eps;
        end;
        if (err4Vect(k)<minerr4) then
            minerr4 = err4Vect(k);
            herrmin4 = h;
        end;

        if (k/500 == int(k/500))
            printf("\n\nDiferente finite centrate de ordinul 4:\n");
            printf("Eroarea: %e\n",err4Vect(k));
            printf("Pasul de derivare: %f\n",h);
        end;

    end;

    // ordinul 4
    printf("\n\nDiferente finite centrate de ordinul 4:\n");
    printf("Eroarea minima: %e\n",minerr4);
    printf("Pasul de derivare: %f\n",herrmin4);

    //xclear();
    xname('Graficul erorii in functie de pasul ...
    de derivare');
    xtitle('Eroarea de derivare pentru ordinul 4','h','err(h)');
    xsetech([0,0,1,1]);

    plot2d('ll',hVect',err4Vect',5);
    xgrid();
    wait2close();

    k=0;
    clear hVect;
    hini = 0.0001;
    pash = 0.0001;
    hmax = 0.1;
    minerr6 = 1e+7;
    herrmin6 = hini;
    for h = hini:pash:hmax,
        k = k+1;
        hVect(k) = h;

        de_ord6 = (-sin(x0-3*h) + 9*sin(x0-2*h) - ...
        45*sin(x0-h) + 45*sin(x0+h) - ...
        9*sin(x0+2*h) + sin(x0+3*h)) / (60*h);
        err6Vect(k) = abs(de_ord6 - de_ex);
        if (err6Vect(k)<%eps)
            err6Vect(k) = %eps;
        end;
        if (err6Vect(k)<minerr6) then
            minerr6 = err6Vect(k);
            herrmin6 = h;
        end;

        if (k/500 == int(k/500))
            printf("\n\nDiferente finite centrate de ordinul 6:\n");
            printf("Eroarea: %e\n",err6Vect(k));
            printf("Pasul de derivare: %f\n",h);
        end;

    end;

    // ordinul 6
    printf("\n\nDiferente finite centrate de ordinul 6:\n");
    printf("Eroarea minima: %e\n",minerr6);
    printf("Pasul de derivare: %f\n",herrmin6);

    //xclear();
    xname('Graficul erorii in functie de pasul de derivare');
    xtitle('Eroarea de derivare pentru ordinul 6','h','err(h)');
    xsetech([0,0,1,1]);

    plot2d('ll',hVect',err6Vect',5);
    xgrid();
    wait2close();
endfunction

function [] = rezultate3(ord_der, xMin, xMax, nr_noduri)
    exec('functii/derivare.sci');
    exec('functii/alte_functii.sci');

    h = (xMax-xMin) / (nr_noduri-1);

    for col = 1:nr_noduri,
        depo(1,col) = xMin + (col-1)*h;
        depo(2,col) = exp(depo(1,col));
    end;

    for _lin = 2:ord_der+1,
        // in punctele interioare -  diferente finite centrate de
        // ordinul II
        for col = 2:nr_noduri-1,
            depo(_lin+1,col) = (depo(_lin,col+1) - ...
            depo(_lin,col-1)) / (2*h);
        end;
        // in punctele periferice diferente finite progresive,
        // respectiv regresive de ordinul III
        depo(_lin+1,1) = (-11*depo(_lin,1) + 18*depo(_lin,2) - ...
        9*depo(_lin,3) + 2*depo(_lin,4)) / (6*h);
        depo(_lin+1,nr_noduri) = (11*depo(_lin,nr_noduri) - ...
        18*depo(_lin,nr_noduri-1) + ... 
        9*depo(_lin,nr_noduri-2) - ...
        2*depo(_lin,nr_noduri-3)) / (6*h);

        // reprezentarea grafica a functiei exponentiale si a 
        // derivatelor de ordin superior
        //xclear();
        xname('Graficul functiei exponentiale si al derivatelor de ordin superior:');
        txt = string(_lin-1);
        xtitle('Functia f(x)=exp(x) si derivata numerica de ordinul '+txt,'x','exp(x)');
        xsetech([0,0,1,1]);

        plot2d(depo(1,:)',depo(2,:)',3); //,5,"005","");
        plot2d(depo(1,:)',depo(_lin,:)',5); //,3,"004","");
        wait2close();
    end;
endfunction
